////////////////////////////////////////////////////////////////////////////////
//
//		Title		: NScrollBar.h File
//
//		Copyright (C) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
//
//		Team		: Desktop Service Development
//
//		author		: hhd2002
//
//		created		: 11:12:2006   13:40
//  
//////////////////////////////////////////////////////////////////////////////// 
#pragma once

#include "NPCommonUI.h"
#include "Panel.h"
#include "ScrollEvent.h"
#include "MouseEvent.h"
#include "Layout.h" 
#include "ScrollBarTimer.h"
#include "RootContainer.h"

static const DWORD NSB_STYLE_HSCROLL = 0x1; /* {kr} ũѹ Ÿ, Ⱦũѹ Ÿ {/kr} */
static const DWORD NSB_STYLE_VSCROLL = 0x2; /* {kr} ũѹ Ÿ {/kr} */
static const DWORD NSB_STYLE_HANDLE = 0x4; /* {kr} ڵ ִ ũѹ Ÿ {/kr} */
static const DWORD NSB_TIMERID_HANDLE =	1000; /* {kr} ڵг  Ÿ̸ ̵ {/kr}  */
static const DWORD NSB_TIMERID_SHAFT = 1001; /* {kr} shaftг  Ÿ̸ ̵ {/kr} */ 
static const DWORD NSB_TIMERID_LUBTN = 1002; /* {kr} LeftUpг  Ÿ̸ ̵ {/kr} */ 
static const DWORD NSB_TIMERID_RDBTN = 1003; /* {kr} RightDownг  Ÿ̸ ̵ {/kr} */

class CN4StatePanel;
class CNScrollBarListener;
class CNScrollBarLeftUpPanelListener;
class CNScrollBarRightDownPanelListener;
class CNScrollBarThumbPanelListener;
class CNScrollBarHandlePanelListener;
interface IScrollBarUI;
interface IScrollBarCustomize;
class CDefScrollBarCustomize;

/**
* \group CommonUI
* \brief {kr} NScrollBar Ŭ {/kr}
* \date 2006-11-03
* \author hhd2002
* \remark {kr} windows system scrollbar  +  ڵ ũѹ(from Picasa) {/kr}
*/
class NPCOMMONUI_API CNScrollBar 
	: public CContainer
	, public ILayoutManager
	, public INPTimerHandler
{
	DECLARE_RTTI
	friend CNScrollBarListener;
	friend CNScrollBarLeftUpPanelListener;
	friend CNScrollBarRightDownPanelListener;
	friend CNScrollBarThumbPanelListener;
	friend CNScrollBarHandlePanelListener;
	friend CDefScrollBarCustomize;

public:
	/**
	 * \brief {kr} ũѹ  {/kr}
	 * \param pNSBUI {kr} ũѹ UI {/kr}
	 * \param dwStyle {kr} ũѹ Ÿ {/kr}
	 * \param nButtonWidth {kr} ũѹ ư  {/kr}
	 * \param nThumbWidth {kr} ũѹ   {/kr}
	 * \param nHandleWidth {kr} ũѹ ڵ  {/kr}
	 * \param pScrollBarCustomize {kr} ũѹ customize set {/kr}
	 */
	CNScrollBar(	IScrollBarUI* pNSBUI = NULL, 
					DWORD dwStyle = NSB_STYLE_HSCROLL, 
					int nButtonWidth = 0, 
					int nThumbWidth = 0,
					int nHandleWidth = 0, 
					IScrollBarCustomize* pScrollBarCustomize = NULL	);
	virtual ~CNScrollBar();

	/**
	* \brief				{kr} SCROLLINFO ´. {/kr}
	* \param lpScrollInfo	{kr} [out] SCROLLINFO  {/kr} 
	*/
	BOOL	GetScrollInfo(LPSCROLLINFO lpScrollInfo, UINT nMask = SIF_ALL);

	/**
	* \brief				{kr} ũ ִ  Ѵ. {/kr}
	* \return				{kr}  : ũ ִ  .  : 0 . {/kr}
	*/
	int		GetScrollLimit();

	/**
	* \brief				{kr} ũ ڽ  ġ Ѵ. {/kr}
	* \remark 				{kr}  ũ ڽ ġ  ̴.   100~200  150 ̴߰. {/kr}
	* \return				{kr}  : ũ ڽ  ġ .  : 0 . {/kr}
	*/
	int		GetScrollPos( );

	/**
	* \brief				{kr} ũѹ   ´. {/kr}
	* \remark 				{kr} Ʈ Ѵ 0. {/kr}
	* \param lpMinPos		{kr} ּҰ  {/kr}
	* \param lpMaxPos		{kr} ִ밪  {/kr}
	*/
	void	GetScrollRange(LPINT lpMinPos, LPINT lpMaxPos);

	/**
	* \brief				{kr} SCROLLINFO Ѵ. {/kr}
	* \remark 				{kr}  {/kr}
	* \param lpScrollInfo	{kr} [in] SCROLLINFO . {/kr}
	* \param bRedraw		{kr} [in]	TRUE :   ݿϿ ũѹٸ ٽ ׷ش.
		FALSE : ٽ ׸ ʴ´. {/kr}
	* \return				{kr}  : TRUE . {/kr}
	*/
	int		SetScrollInfo(LPSCROLLINFO lpScrollInfo, BOOL bRedraw = TRUE);

	/**
	* \brief				{kr}  ũ ڽ ġ nPos ϰ bRedraw Ǵؼ ٽ ׸. {/kr}
	* \remark 				{kr}  {/kr}
	* \param nPos			{kr} [in] ũ ڽ  ġ.   ũ  ̳ ̾ Ѵ. {/kr}
	* \param bRedraw		{kr} [in] TRUE :  ġ  ũѹٸ  ׸. {/kr}
	* \return				{kr} bRedraw FALSE   ªð ؼ ٸ  
		SetScrollPos ȣ  Ѵ. {/kr}
	*/
	int		SetScrollPos(int nPos, BOOL bRedraw = TRUE);

	/**
	* \brief				{kr} ũѹ ּ, ִ  Ѵ. {/kr}
	* \remark 				{kr} nMinPos, nMaxPos 0̸ ũѹٰ Ȱȴ. SetScrollRange ȣĿ ٷ SetScrollRange
								ȣϴ 쿡 SetScrollPos bRedrawn FALSE Ѵ  2 ٽ ׸  ´.
								  ִ 32767̴.{/kr}
	* \param nMinPos		{kr} [in] ּ . {/kr}
	* \param nMaxPos		{kr} [in] ִ . {/kr}
	* \param bRedraw		{kr} [in]	TRUE :   ݿϿ ũѹٸ ٽ ׷ش.
							FALSE : ٽ ׸ ʴ´. {/kr}
	*/
	void	SetScrollRange(int nMinPos, int nMaxPos, BOOL bRedraw = TRUE);

	/**
	* \brief				{kr} ũѹٸ /. {/kr}
	* \remark 				{kr} APP ũѹ ޽ ް  ɼ  Լ ȣϸ ȵȴ. {/kr}
	* \param bShow			{kr} TRUE : ũѹٸ . {/kr}
	*/
	void	ShowScrollBar(BOOL bShow = TRUE);

	/**
	* \brief	{kr} ũѸʸ ߰. {/kr}
	* \param pScrollListener {kr} ߰Ϸ ũѸ. {/kr}
	*/
	void	AddScrollListener(IScrollListener* pScrollListener);

	/**
	* \brief	{kr} ũѸʸ . {/kr}
	* \param pScrollListener {kr} Ϸ ũ . {/kr}
	*/
	void	RemoveScrollListener(IScrollListener* pScrollListener);

	/**
	* \brief	{kr} ڵɼ ԷѴ. {/kr}
	* \param dwMinTime {kr} ڵ齺ũѽ ũ notify ޽ ּ hop ð. {/kr}
	* \param nHandleHop {kr} ڵ齺ũѽ ũ notify ޽ hop width. {/kr}
	*/
	void	SetHandleOption(DWORD dwMinTime = 10, int nHandleHop = 1, int nTimeMultiplyNum = 10, int nHopMultiplyNum = 10);

	/**
	* \brief	{kr} ڵɼ ´. {/kr}
	* \param pdwMinTime {kr} [out] ڵ齺ũѽ ũ notify ޽ ּ hop ð. {/kr}
	* \param pnHandleHop {kr} [out] ڵ齺ũѽ ũ notify ޽ hop width. {/kr}
	*/
	void	GetHandleOption(DWORD* pdwMinTime, int* pnHandleHop);

	//telltale
	void SetTimerPeriod(DWORD dwTimerPeriod)
	{
		m_dwMinTime = dwTimerPeriod;
	}
	/**
	* \brief	{kr} UIŬ . {/kr}
	* \param pComponentUI {kr} UIŬ {/kr}
	*/
	virtual void	SetUI(IComponentUI* pComponentUI);

	/**
	* \brief	{kr} Ÿ . {/kr}
	* \param dwStyle {kr} NSB_HSCROLL, ... {/kr}
	*/
	void	ModifyStyle(DWORD dwStyle);

	/**
	 * \brief 	{kr} ũѹٸ ׸. {/kr}
	 * \param hDC 
	 */
	virtual void OnDraw(HDC hDC);

	/**
	 * \brief 	{kr} ũѹ  disable/enable   {/kr}
	 * \param bEnable {kr} TRUE̸ enable FALSE̸ disable {/kr}
	 */
	void Enable(BOOL bEnable = TRUE);

	/**
	 * \brief 	{kr} ũѹٰ Ȱȭ ? {/kr}
	 * \return 
	 */
	BOOL IsEnable()
	{
		return m_bEnable;
	}

	/**
	 * \brief 	{kr} ڵ Ʈ Ѵ, 
					 -1(ڵ shaft / ) ~ 0(ڵ shaft ߾) ~ 1(ڵ shaft Ʒ/ ) {/kr}
	 */
	float GetHandleMoment()
	{
		return m_fHandleMoment;
	}

	/* \brief ° {/kr} */ 
	enum eNSBState
	{
		E_NSB_STATE_NONE,		/* {kr} \brief ⺻  {/kr} */
		E_NSB_STATE_SELECTED,	/* {kr} \brief õ  {/kr} */
		E_NSB_STATE_OVER,		/* {kr} \brief 콺 hover  {/kr} */
		E_NSB_STATE_DISABLED,	/* {kr} \brief Ȱȭ  {/kr} */
	};

	/**
	* \brief {kr}  ũѹ ¸ ´. {/kr}
	* \return {kr} ũѹ  {/kr}
	*/
	eNSBState GetState()
	{
		return m_state;
	}

	int GetBtnWidth()
	{
		return m_nBtnWidth;
	}

	CNScrollBarTimer	m_Timer;	/* {kr} ũѹ ü Ÿ̸ {/kr} */ 

protected:
	/**
	 * @breif {kr} WM_SIZE _RefreshPosȣ. {/kr}
	 */
	virtual void	LayoutContainer(CContainer* pContainer);
	/**
	 * @breif {kr} ũ ̺Ʈ ش. {/kr}
	 */
	virtual	void	FireScroll(CScrollEvent* pScrollEvent);
	
	/**
	 * @breif {kr} ڵ, shaft, leftupư, rightdownư Ŭÿ  Ÿ̸Ӱ ̴µ,
		̶ Ÿ̸ ̺Ʈ ߻ÿ ũ  ó ش. {/kr}
	 * @param dwTimerID {kr}  Ÿ̸ ̵ {/kr}
	 */
	virtual  BOOL OnTimer( DWORD dwTimerID);

private:

	/**
	 * @breif {kr} ũѹ    component ġ refresh ش. {/kr}
	 */
	void	_RefreshPos();

	int							m_nHandleHop; /* {kr} ѹ hopping Ǵ unit {/kr} */
	BOOL						m_bHScroll; /* {kr}  ũѹٰ Horizontal? {/kr} */
	BOOL						m_bHandle; 
	BOOL						m_bEnable; /* {kr}  ũѹٰ Ȱȭ? {/kr} */
	BOOL						m_bForcedTimerStop; /* {kr}  Ÿ̸ ϴ ÷ {/kr} */
	BOOL						m_bMouseCaptured;
	BOOL						m_bIsLeftUp;
	int							m_nMargin; /* {kr} ũѹ  մ ,  ڸ ư    ִ. {/kr} */
	int							m_nBtnWidth; /* {kr} ũѹ ư  {/kr} */
	int							m_nThumbWidth; /* {kr} ũѹ   {/kr} */
	int							m_nHandleWidth; /* {kr} ũѹ ڵ  {/kr} */
	int							m_nTimeMultiplyNum; /* {kr} ũѹ Ÿ̸ ֱ ִ {/kr} */
	int							m_nHopMultiplyNum; /* {kr} ũѹ hopping  ִ {/kr} */
	CPoint						m_ptMousePressed; /* {kr} shaft  ȴ? {/kr} */
	CRect						m_rcMidHandle; /* {kr} ũѹ ڵ  ߾  ڸ {/kr} */
	CRect						m_rcShaftSelected; /* {kr} shaft selectǾ Ǿ ϴ shaft {/kr} */
	DWORD						m_dwMinTime; /* {kr} ڵ ߻ù̴ ּ Ÿ̸ ֱ, 
												 ֱ ư,  Ÿ̸ֱ . {/kr} */
	DWORD						m_dwCurrentTimerPeriod; /* {kr}  Ÿ̸ ֱ {/kr} */
	DWORD						m_dwTimerStartTime; /* {kr} tickcount fire scrollÿ  ۽ð {/kr} */
	DWORD						m_dwTimerElasedTime; /* {kr} fire scrollĿ  Ÿ̸ ̺Ʈ ѽð {/kr} */
	float						m_fHandleMoment; /* {kr} ڵ ߾   , 0(߾)~1() {/kr} */
	SCROLLINFO					m_si; /* {kr}  ũѹ scroll infomation {/kr} */
	eNSBState					m_state; /* {kr}  ũѹ shaft mouse event {/kr} */
	CAtlList<IScrollListener*>	m_vActionListener; /* {kr} ũѹ shaft mouse event  listeners {/kr} */
	
	IScrollBarUI*				m_pNSBUI; /* {kr} ũѹ UI {/kr} */

	CN4StatePanel*					m_pLUPanel; /* {kr} Left Up Panel {/kr} */
	CN4StatePanel*					m_pRDPanel; /* {kr} Right Down Panel {/kr} */
	CN4StatePanel*					m_pHandlePanel; /* {kr} ڵ г {/kr} */
	CN4StatePanel*					m_pThumbPanel; /* {kr}  г {/kr} */	

	IMouseListener*				m_pShaftListener;
	IMouseListener*				m_pLeftUpPanelListener;
	IMouseListener*				m_pRightDownPanelListener;
	IMouseListener*				m_pThumbPanelListener;
	IMouseListener*				m_pHandlePanelListener;

	IScrollBarCustomize*		m_pScrollBarCustomize; ///< {kr} ũѹ  ۿ  action customize. {/kr}
	BOOL						m_bAllocScrollBarCustom;
};

/**
 * \ingroup	NPCommonUI
 * \date 2007-04-06
 * \author hhd
 * \brief {kr} shaft 콺 ̺Ʈ ó. {/kr}
 */
class CNScrollBarListener : public IMouseListener
{
public:
	CNScrollBarListener(CNScrollBar* pNSB)
	{
		m_pNSB = pNSB;
	}

	/**
	* \brief	{kr} Lư  ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMousePressed(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} Lư UPɶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseReleased(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ  ö ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseEntered(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ    ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseExited(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ ϶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseMoved(CMouseEvent* pMouseEvent);

	/**
	* \brief 	{kr} 콺 ϶ ȣ. {/kr}
	* \param pMouseEvent 
	*/
	virtual void	OnMouseWheelMoved(CMouseEvent* pMouseEvent);

private:
	CNScrollBar* m_pNSB;
};

/**
* \group CommonUI
* \brief {kr} LUư  Ŭ {/kr}
* \date 2006-11-03
* \author hhd2002
*/
class CNScrollBarLeftUpPanelListener : public IMouseListener
{
public:
	CNScrollBarLeftUpPanelListener(CNScrollBar* pNSB)
	{
		m_pNSB = pNSB;
	}

	/**
	* \brief	{kr} Lư  ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMousePressed(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} Lư UPɶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseReleased(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ  ö ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseEntered(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ    ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseExited(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ ϶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseMoved(CMouseEvent* pMouseEvent);

	/**
	* \brief 	{kr} 콺 ϶ ȣ. {/kr}
	* \param pMouseEvent 
	*/
	virtual void	OnMouseWheelMoved(CMouseEvent* pMouseEvent);

private:
	CNScrollBar* m_pNSB;
};

/**
* \group CommonUI
* \brief {kr} RDư  Ŭ {/kr}
* \date 2006-11-03
* \author hhd2002
* \remark {kr}  {/kr}
*/
class CNScrollBarRightDownPanelListener : public IMouseListener
{
public:
	CNScrollBarRightDownPanelListener(CNScrollBar* pNSB)
	{
		m_pNSB = pNSB;
	}

	/**
	* \brief	{kr} Lư  ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMousePressed(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} Lư UPɶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseReleased(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ  ö ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseEntered(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ    ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseExited(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ ϶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseMoved(CMouseEvent* pMouseEvent);

	/**
	* \brief 	{kr} 콺 ϶ ȣ. {/kr}
	* \param pMouseEvent 
	*/
	virtual void	OnMouseWheelMoved(CMouseEvent* pMouseEvent);

private:
	CNScrollBar* m_pNSB;
};

/**
* \group CommonUI
* \brief {kr} г  Ŭ {/kr}
* \date 2006-11-03
* \author hhd2002
* \remark {kr}  {/kr}
*/
class CNScrollBarThumbPanelListener : public IMouseListener
{
public :
	CNScrollBarThumbPanelListener(CNScrollBar* pNSB)
	{
		m_pNSB = pNSB;
		m_bMousePressed = FALSE;
	}

	/**
	* \brief	{kr} Lư  ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMousePressed(CMouseEvent* pMouseEvent);
	
	/**
	* \brief	{kr} Lư UPɶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseReleased(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ  ö ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseEntered(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ    ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseExited(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ ϶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseMoved(CMouseEvent* pMouseEvent);

	/**
	 * \brief 	{kr} 콺 ϶ ȣ. {/kr}
	 * \param pMouseEvent 
	 */
	virtual void	OnMouseWheelMoved(CMouseEvent* pMouseEvent);

private:
	CNScrollBar* m_pNSB;
	CPoint m_ptOld;
	BOOL m_bMousePressed;
};

/**
* \group CommonUI
* \brief {kr} ڵг  {/kr}
* \date 2006-11-03
* \author hhd2002
* \remark {kr}  {/kr}
*/
class CNScrollBarHandlePanelListener : public IMouseListener
{
public:
	CNScrollBarHandlePanelListener(CNScrollBar* pNSB)
	{
		m_pNSB = pNSB;
		m_bMousePressed = FALSE;
		//m_bIsFirstMovement = TRUE;
	}

	/**
	* \brief	{kr} Lư  ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMousePressed(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} Lư UPɶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseReleased(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ  ö ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseEntered(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ    ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseExited(CMouseEvent* pMouseEvent);

	/**
	* \brief	{kr} 콺Ͱ ϶ ȣ. {/kr}
	* \param pMouseEvent {kr} 콺̺Ʈ {/kr}
	*/
	virtual void	OnMouseMoved(CMouseEvent* pMouseEvent);

	/**
	* \brief 	{kr} 콺 ϶ ȣ. {/kr}
	* \param pMouseEvent 
	*/
	virtual void	OnMouseWheelMoved(CMouseEvent* pMouseEvent);

private:
	CNScrollBar* m_pNSB;
	BOOL m_bMousePressed;
	CPoint m_ptOld;
	//BOOL m_bIsFirstMovement;
};

/**
* \group CommonUI
* \brief {kr} ũѹ UI ̽ {/kr}
* \date 2006-11-03
* \author hhd2002
* \remark {kr}  {/kr}
*/
interface NPCOMMONUI_API IScrollBarUI : public IComponentUI
{
	DECLARE_RTTI
public:
	virtual ~IScrollBarUI() {  }

	virtual void		DrawBackground(HDC hDC, CNScrollBar* pNSB, PRECT pRcShaftSelected) = 0;
	virtual void		SetLUPanelUI(IPanelUI* pPanelUI) = 0;
	virtual IPanelUI*	GetLUPanelUI() = 0;
	virtual void		SetRDPanelUI(IPanelUI* pPanelUI) = 0;
	virtual IPanelUI*	GetRDPanelUI() = 0;
	virtual void		SetThumbPanelUI(IPanelUI* pPanelUI) = 0;
	virtual IPanelUI*	GetThumbPanelUI() = 0;
	virtual void		SetHandlePanelUI(IPanelUI* pPanelUI) = 0;
	virtual IPanelUI*	GetHandlePanelUI() = 0; 
};

/**
* \group CommonUI
* \brief {kr} ũѹ costomize ̽ {/kr}
* \date 2006-11-03
* \author hhd2002
* \remark {kr} parent class  ̽ ؼ ũѹٸ customize  ִ.{/kr}
*/
interface NPCOMMONUI_API IScrollBarCustomize
{
	DECLARE_ROOT_RTTI

public:
	virtual ~IScrollBarCustomize() {  }
	/**
	 * \brief 	{kr} Shaft Down ÿ ߻ {/kr}
	 * \param bIsLeftUp {kr} shaft LeftUp Ŭ? {/kr}
	 */	 
	virtual void		OnShaftDown(BOOL bIsLeftUp) = 0;
	
	/**
	 * \brief 	{kr} Shaft Up ÿ ߻ {/kr}
	 */
	virtual void		OnShaftUp() = 0;
	virtual void		OnLeftUpPanelDown() = 0;
	virtual void		OnLeftUpPanelUp() = 0;
	virtual void		OnRightDownPanelDown() = 0;
	virtual void		OnRightDownPanelUp() = 0;
	virtual void		OnHandlePanelDown() = 0;
	virtual void		OnHandlePanelUp() = 0;
	virtual void		OnHandlePanelMove() = 0;
};

/**
 * \group Common UI
 * \brief {kr} ũѹ customize ⺻ set {/kr}
 * \date 2007-01-18
 * \author hhd2002
 * \remark {kr} ũѹ ⺻ Ǵ customize set. ũѹ  timer ̴ ũѹٰ ȴ. {/kr}
 */
class CDefScrollBarCustomize : public IScrollBarCustomize
{
	DECLARE_RTTI

public:
	CDefScrollBarCustomize(CNScrollBar* pNSB)
	{
		ATLASSERT(IS_EXACT_CLASS(CNScrollBar, pNSB));
		if(IS_EXACT_CLASS(CNScrollBar, pNSB) == FALSE) return;

		m_pNSB = pNSB;
		m_bIsFirstMovement = TRUE;
	}

	virtual void		OnShaftDown(BOOL bIsLeftUp);
	virtual void		OnShaftUp();
	virtual void		OnLeftUpPanelDown();
	virtual void		OnLeftUpPanelUp();
	virtual void		OnRightDownPanelDown();
	virtual void		OnRightDownPanelUp();
	virtual void		OnHandlePanelDown();
	virtual void		OnHandlePanelUp();
	virtual void		OnHandlePanelMove();

private:
	CNScrollBar* m_pNSB; ///< {kr} customize  Ǵ ũѹ ü {/kr}
	BOOL m_bIsFirstMovement;
};